/*@
theory uses Base, java.io.PrintStream {
  int: TYPE = Base.int;
  intArray: TYPE = Base.IntArray;
  nullArray: intArray = Base.nullIntArray;
  isSorted: PREDICATE(intArray, int, int) =
    PRED(a: intArray, from: int, to: int): 
      FORALL(i: INT): from <= i AND i < to-1 => a.value[i] <= a.value[i+1];
  arePermutation: PREDICATE(intArray, intArray, int) =
    PRED(a: intArray, b: intArray, n: int):
      EXISTS(p: ARRAY NAT OF NAT):
        (FORALL(j: NAT): j < n => (EXISTS(i: NAT): i < n AND p[i]=j)) AND
        (FORALL(i: NAT): i < n => p[i] < n AND a.value[i] = b.value[p[i]]);
  areIdentical: PREDICATE(intArray, intArray, int, int) =
    PRED(a: intArray, b: intArray, from: int, to: int):
       FORALL(i: int): from <= i AND i < to => a.value[i] = b.value[i];
  identity: ARRAY NAT OF NAT = ARRAY(n:NAT): n;
  insertionLemma: FORMULA
    FORALL(p: ARRAY NAT OF NAT, i: NAT, j: NAT): j <= i =>
      (EXISTS(q: ARRAY NAT OF NAT):
         (FORALL(k: NAT):
            (k < j OR k > i => q[k] = p[k]) AND
            (k = j => q[k] = p[i]) AND
            (j < k AND k <= i => q[k] = p[k-1])));
}
@*/
class Arrays0
{
  public static void main(String[] args) /*@
    requires (VAR System.out).null = FALSE;
  @*/
  {
    int n = 10;
    int[] b = new int[n];
    for (int i=0; i<n; i++) /*@
      invariant (VAR b).null = FALSE 
            AND VAR n = (VAR b).length
            AND 0 <= VAR i AND VAR i <= VAR n;
      decreases (VAR n)-(VAR i);
    @*/
      b[i] = n-i;
    insertionSort(b);
    //@ assert isSorted(VAR b, 0, VAR n);
    assert b != null;
    System.out.println("done");
  }
  
  public static void insertionSort(int[] a) /*@
    requires (VAR a).null = FALSE;
    assignable a;
    ensures (VAR a).null = FALSE AND
       (LET n = (OLD a).length IN
       n = (VAR a).length AND
       isSorted(VAR a, 0, n) AND
       arePermutation(VAR a, OLD a, n));
  @*/
  {
    int n = a.length; 
    for (int i = 1; i < n; i++) /*@
    invariant
       (VAR a).null = FALSE AND (OLD a).null = FALSE AND
       VAR n = (OLD a).length AND VAR n = (VAR a).length AND
       1 <= VAR i AND (VAR n > 0 => VAR i <= VAR n) AND
       areIdentical(VAR a, OLD a, VAR i, VAR n) AND
       isSorted(VAR a, 0, VAR i) AND 
       arePermutation(VAR a, OLD a, VAR n);
    decreases VAR n - VAR i + 1;
    @*/
    {
      int x = a[i];
      int j = i-1;
      while (j >= 0 && a[j] > x) /*@
      invariant
        (VAR a).null = FALSE AND (OLD a).null = FALSE AND
        VAR n = (OLD a).length AND VAR n = (VAR a).length AND
        1 <= VAR i AND VAR i < VAR n AND
        VAR x = (OLD a).value[VAR i] AND
        -1 <= VAR j AND VAR j <= VAR i - 1 AND
        areIdentical(VAR a, OLD a, 1+VAR i, VAR n) AND
        areIdentical(VAR a, OLD a, 0, 1+VAR j) AND
        (FORALL(k:int): VAR j < k AND k < VAR i =>
          (VAR a).value[k+1] = (OLD a).value[k] AND
          (OLD a).value[k] > VAR x);
      decreases VAR j + 1;
      @*/ 
      {
        a[j+1] = a[j];
        j = j-1;
      }
      a[j+1] = x;
    }
  }
}






















