// ----------------------------------------------------------------------------
// ProofCommand.java
// Interface to proof commands.
// $Id: ProofCommand.java,v 1.2 2008/10/13 09:32:00 schreine Exp $
//
// Author: Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
// Copyright (C) 2005, Research Institute for Symbolic Computation (RISC)
// Johannes Kepler University, Linz, Austria, http://www.risc.uni-linz.ac.at
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
// ----------------------------------------------------------------------------
package fmrisc.ProofNavigator.Commands;

import fmrisc.ProofNavigator.Proving.*;

/**
 * 
 * Interface to proof commands.
 *
 */
public interface ProofCommand extends Command
{
  /****************************************************************************
   * process proof state.
   * @param state the state to which the proof command is applied 
   *        (remains unchanged)
   * @return a sequence of children of state generated by the command
   *         (null, if the command did not generate any)
   ***************************************************************************/
  public ProofState[] process(ProofState state);
}
